
(define *bmc-name* "SAL Infinite Bounded Model Checker")
(define *bmc-usage* 
"Usage: sal-inf-bmc [options] <context-name> <assertion-name>
   or  sal-inf-bmc [options] <file-name> <assertion-name>
   or  sal-inf-bmc [options] --assertion='<assertion-expr>'")
(define *bmc-examples* "Examples:
  sal-inf-bmc inf-bakery mutex
 
  sal-inf-bmc ~/examples/inf-bakery.sal mutex

  sal-inf-bmc -d 15 -v 3 ../tmp/inf-bakery.sal mutex")

(front-end/set-categories! '("Help" "Misc" "Assertion" "Pretty Printing" "Code Transformations" "Extra Code Transformations" "Abstraction" "Traceability" "Path Pretty Printing" "LTL Support" "Verification"))

(sal/load-source! "sal-bmc-core-front-end.scm")

(define (bmc/make-assertion qualified-name-str)
	(make-flat-assertion qualified-name-str #t))

(define (bmc/make-lemmas lemmas assertion-qualified-name assertion)
	(sal-inf-bmc/create-assertion-lemmas lemmas assertion-qualified-name assertion))

(define (bmc/invariant assertion)
	(sal-inf-bmc/invariant assertion *from-depth* *to-depth* *acyclic?* (not *iterative?*) *solver-id*))

(define (bmc/liveness assertion)
	(sal-inf-bmc/liveness assertion *to-depth* (not *iterative?*) *solver-id*))

(define (bmc/k-induction assertion lemma-exprs)
	(sal-inf-bmc/k-induction assertion *to-depth* lemma-exprs *solver-id*))

(sal-bmc/main)

